--imports
local Terminal = require("dogma.syn._.Terminal")
local TerminalType = require("dogma.syn.TerminalType")

--An array terminal node.
local LiteralFn = {}
LiteralFn.__index = LiteralFn
setmetatable(LiteralFn, {__index = Terminal})
package.loaded[...] = LiteralFn

--Constructor.
function LiteralFn.new(ln, col, async, params, rtype, rvar, catch, body)
  return setmetatable(Terminal.new(TerminalType.FN, {
    line = ln,
    col = col,
    value = {
      async = async,
      params = params,
      rtype = rtype,
      rvar = rvar,
      catch = catch,
      body = body
    }
  }), LiteralFn)
end

--@override
function LiteralFn:__tostring()
  local desc

  if self.data.async then
    desc = "async fn("
  else
    desc = "fn("
  end

  for i, p in ipairs(self.data.params) do
    desc = desc .. (i == 1 and "" or ", ") .. p.name
  end
  desc = desc .. ")"

  if self.data.catch then
    desc = desc .. " => " .. tostring(self.data.catch)
  end

  desc = desc .. "{"
  for i, s in ipairs(self.data.body) do
    desc = desc .. (i == 1 and "" or "; ") .. tostring(s)
  end
  desc = desc .. "}"

  return desc
end
